[![Actions Status](https://github.com/rienafairefr/pyrebrickable/workflows/python-package/badge.svg)](https://github.com/rienafairefr/pyrebrickable/actions)
[![Coverage Status](https://coveralls.io/repos/github/rienafairefr/pyrebrickable/badge.svg?branch=master)](https://coveralls.io/github/rienafairefr/pyrebrickable?branch=master)

# pyrebrickable

This is pyrebrickable, a package for interacting with rebrickable (www.rebrickable.com=)

Documentation can be found in the accompanying Pages [here](https://rienafairefr.github.io/pyrebrickable)

## rebrickable.api

The rebrickable.api hierarchy was automatically generated by [OpenAPI generator](https://github.com/openapitools/openapi-generator) project,

## CLI

This Python package provides a CLI wrapper around the Rebrickable API<br> <br> It supports the v3 API through it's openAPI specification.<br> https://rebrickable.com/api/v3/swagger/?format=openapi<br> Models for Part, Set, etc. have been manually added to provide meaningful results from HTTP responses<br> <br> Some endpoints might not work, don't hesitate to file an issue<br>

Once the pyrebrickable package is installed through `pip install pyrebrickable` you should have access to a `rebrickable` command.

## rebrickable.data

This package makes use of the monthly CSV database dumps, import them into a
local database and provide you a way through SQLAlchemy to query that
database

You can access it through its CLI at `rebrickable-data`

# Requirements.

Python 2.7 and 3.5+

# Installation & Usage

```
pip install pyrebrickable
```

# Getting Started

For the CLI: with the package installed, run

`rebrickable --help`

You can also read the [CLI docs](https://rienafairefr.gitlab.io/pyrebrickable/cli.html), auto-generated documentation from the [Click](http//click.pocoo.org) definitions in [cli.py](rebrickable/cli.py)

To use the API, use `from rebrickable_api import [...]`, see the [API docs](https://rienafairefr.gitlab.io/pyrebrickable/api.html) for how to use it

To use the rebrickable_data package, see [Data docs](https://rienafairefr.gitlab.io/pyrebrickable/data.html) and some examples in [the repo](data/examples)

## Author

Matthieu Berthomé @rienafairefr


[]: https://travis-ci.org/rienafairefr/pyrebrickable